#!/usr/bin/env python3
# python_val.py
# Glenn G. Chappell
# 9 Mar 2013
#
# For CS 331 Spring 2013
# Code from 3/9: Python: Values & Functions

import copy            # for copy.copy, copy.deepcopy
import urllib.request  # for urllib.request.urlopen


# ***** Values *****


def use_types():
    """Print values of various types."""

    print("Big integer:")
    print(2**1000)
    print()

    print("Dictionary values:")
    d = { 1:"hi", "ho":3 }
    d[2] = "abc"
    print(d["ho"], d[2])


def print_copy_results():
    """Print results of copy, deep copy, modifying values."""

    def print_lists():
        print("list1 (original):", list1)
        print("list2 (assigned):", list2)
        print("list3 (copy):    ", list3)
        print("list4 (deepcopy):", list4)

    list1 = [1,2,[4,5]]
    list2 = list1
    list3 = copy.copy(list1)
    list4 = copy.deepcopy(list1)

    print("Original values:")
    print_lists()
    print()

    list1[0] = 999
    print("Item in original list modified:")
    print_lists()
    print()

    list1[2][0] = 999
    print("\"Deep\" item modified:")
    print_lists()


# ***** Functions *****


def optional_args(a, b=None, c=None):
    """A function with optional arguments."""

    print(a, b, c)


# Main Program

if __name__ == "__main__":
    print("Demo of various types:")
    use_types()
    print()
    print("---------------------------------------------------------")
    print()

    print("Demo of assignment and copying:")
    print_copy_results()
    print()
    print("---------------------------------------------------------")
    print()

    print("Demo of function call with optional arguments:")
    optional_args(1)
    optional_args("hi", c="ho")
    print()

